#include <iostream>
#include <cstdio>
#include <cstring>
#include <string>
#include <cmath>
using namespace std;

int giveDecimalOfHexChar(char c){
	if(c>='0' && c<='9') return c-'0';
	else return c-'a'+10;
}

char givehexCharOfDecimal(int x){
	if(x<=9) return '0'+x;
	else return 'a' + x - 10;
}


struct bitVector{
	long bitWidth;
	string hexadecimalString;
	bitVector(){
		bitWidth = 0;
		hexadecimalString = "";
	}
	void evaluate();
	void print();
	void add(bitVector bv2);
	void select( long hiIndex,  long lowIndex);
};

void bitVector::evaluate(){
	cout << "Evaluating ";
	print();
	cout << " gives ";
	string newString = "";
	 long len = hexadecimalString.length();
	 long z = bitWidth/4;
	if(z>len){
		newString = hexadecimalString;
		while(z>len){
			newString = '0' + newString;
			z--;
		}
	}
	else{
		newString = newString + hexadecimalString.substr(len-z, z);
		if(bitWidth%4!=0){
			char doubtFul = hexadecimalString.at(len-z-1);
			int temp = giveDecimalOfHexChar(doubtFul);
			int q = (bitWidth%4);
			newString = (char)((temp%int(pow(2,q)))+'0') + newString;
		}
	}
	hexadecimalString = newString;
	print();
	cout << endl;
}

void bitVector::print(){
	cout << "(C " << bitWidth << " " << hexadecimalString << ")";
	return;
}

void bitVector::add(bitVector bv2){
	cout << "Evaluating (add ";
	print();
	cout << " ";
	bv2.print();
	cout << ") gives ";
	
	// hexaDecimalAddition
	string sum="";
	long i = hexadecimalString.length()-1;
	long j = bv2.hexadecimalString.length()-1;
	int carry = 0;
	for(; i>=0 && j>=0; i--, j--){
		int temp = giveDecimalOfHexChar(hexadecimalString[i]) + giveDecimalOfHexChar(bv2.hexadecimalString[j]) + carry;
		carry = temp/16;
		sum = givehexCharOfDecimal(temp%16) + sum;
	}
	for(; i>=0; i--){
		int temp = giveDecimalOfHexChar(hexadecimalString[i]) + carry;
		carry = temp/16;
		sum = givehexCharOfDecimal(temp%16) + sum;
	}
	for(; j>=0; j--){
		int temp = giveDecimalOfHexChar(hexadecimalString[j]) + carry;
		carry = temp/16;
		sum = givehexCharOfDecimal(temp%16) + sum;
	}
	if(carry>0) sum = givehexCharOfDecimal(carry) + sum;
	hexadecimalString = sum;
	bitWidth = 4*(sum.length()-1) + int(log(giveDecimalOfHexChar(sum[0]))/log(2)) +1;
	print();
	cout << endl;
}

// PRE-CONDITION = bitVector is already evaluted
// not-finished
void bitVector::select( long hiIndex,  long lowIndex){
	cout << "Evaluating (select ";
	print();
	cout << " " << hiIndex << " " << lowIndex << ")" << " gives ";
	long len = hexadecimalString.length();
	long begin = len-hiIndex-1;
	long end = len-lowIndex-1;
	string newString = "";
	
	hexadecimalString = newString;
	bitWidth = hiIndex - lowIndex + 1;
	print();
	cout << endl;
}

bitVector understandInput(string &input){
	bitVector *bv = new bitVector;
	long parsedUpto = input.find("(");
	parsedUpto++;
	if(parsedUpto == string::npos) return *bv;
	if(input.at(parsedUpto)=='C'){
		parsedUpto++;
		while(input.at(parsedUpto)==' ') parsedUpto++; // ignore whitespaces
		for(; input.at(parsedUpto)!=' '; parsedUpto++) bv->bitWidth = bv->bitWidth*10 + input.at(parsedUpto) - '0'; // read the bit width
		while(input.at(parsedUpto)==' ') parsedUpto++; // ignore whitespaces
		for(; input.at(parsedUpto)!=')'; parsedUpto++) bv->hexadecimalString +=  input.at(parsedUpto); // read the the hexadecimalString
		bv->evaluate();
		input = input.substr(parsedUpto+1);
		return *bv;
	}
	if(input.at(parsedUpto)=='a'){
		parsedUpto+=3;
		input = input.substr(parsedUpto);
		*bv = understandInput(input);
		bv->add(understandInput(input));
		parsedUpto = input.find(')');
		input = input.substr(parsedUpto+1);
		return *bv;
	}
	if(input.at(parsedUpto)=='s'){
		parsedUpto+=5;
		input = input.substr(parsedUpto);
		*bv = understandInput(input);
		long highIndex = 0;
		long lowIndex = 0;
		parsedUpto = 0;
		while(input.at(parsedUpto)==' ') parsedUpto++; // ignore whitespaces
		for(; input.at(parsedUpto)!=' '; parsedUpto++) highIndex = highIndex*10 + input.at(parsedUpto) - '0'; // read the integer
		while(input.at(parsedUpto)==' ') parsedUpto++; // ignore whitespaces
		for(; input.at(parsedUpto)!=')'; parsedUpto++) lowIndex = lowIndex*10 + input.at(parsedUpto) - '0'; // read the bit width

		bv->select(highIndex, lowIndex);
		parsedUpto = input.find(')');
		input = input.substr(parsedUpto+1);
		return *bv;
	}
	return *bv;
}

int main(){
	string input;
	while(1){
		cout << "BEE> ";
		getline(cin, input);
		if(input.compare("exit")==0){
			cout << "Thank you!" << endl;
			return 0;
		}
		bitVector b = understandInput(input);
	}
}
